# -*- coding: utf-8 -*-

"""
Calcul et affichage de la trajectoire d'une bille de billard lancé
dans un billard rectangulaire.
@author: Loïc Devilliers
"""

##Importation des bibliothèques
import matplotlib.pyplot as plt#Bibliothèque Pyton qui gère l'affichage

##Définition et affichage du billard
L=2         #demi-longueur du côté horizontal
l=1         #demi-longueur du côté vertical
A=[0.1,-l]  #Premier point, peut être n'importe où dans le billard,
#A[0] est l'abscisse de A, A[1] son ordonnée
B=[L,0]     #Deuxième point, nécessairement sur l'un des côtés du billard
N=100       #Nombre de rebonds
plt.plot([L,L,-L,-L,L],[l,-l,-l,l,l],'b')#Affichage des bords du billard:
#liste des abscisses suivie de liste des ordonnées
plt.axis('equal')#Les échelles en x et y sont les mêmes
plt.pause (0.5)

##Zone de script
for k in range(N-1): #Pour chaque k, affichage du dernier segment et calcul de C (rebond suivant)
    plt.plot([A[0],B[0]], [A[1],B[1]],'r')  # Affichage du segment [A,B], 'r' pour rouge
    plt.xlabel(str(k+2))                    # Affichage du nombre de points
    plt.pause(0.1)                          # Pause pour voir la trajectoire défiler

    D=[L,B[1]-(B[1]-A[1])/(B[0]-A[0])*(L-B[0])]#Intersection de (A,B) avec le coté droit
    E=[-L,B[1]-(B[1]-A[1])/(B[0]-A[0])*(-L-B[0])]
    F=[B[0]-(B[0]-A[0])/(B[1]-A[1])*(l-B[1]),l]
    G=[B[0]-(B[0]-A[0])/(B[1]-A[1])*(-l-B[1]),-l]

    if D!=B and abs(D[1])<l:   #On teste si D est dans le segment à droite et D différent de B
        C=D                    #C est le point du rebond suivant
    if E!=B and abs(E[1])<l:   #On teste si E est dans le segment à gauche et E différent de B
        C=E                    #C est le point du rebond suivant
    if F!=B and abs(F[0])<L:   #On teste si F est dans le segment du haut et F différent de B
        C=F                    #C est le point du rebond suivant
    if G!=B and abs(G[0])<L:   #On teste si G est dans le segment du bas et G différent de B
        C=G                    #C est le point du rebond suivant

    A=B    #Avant dernier point de la trajectoire
    B=C    #Dernier point de la trajectoire